package org.convey;

import java.util.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class CompositeGraphicEvent extends GraphicEvent {

	public CompositeGraphicEvent(Vector graphicEvents) {
		super(graphicEvents);
	}

	public Graphic getGraphic() {
		if(((Vector)super.source).size() > 0)
			return ((GraphicEvent)((Vector)super.source).elementAt(0)).getGraphic();

		return null;
	}

	public void setGraphic(Graphic graphic) {
		if(((Vector)super.source).size() > 0)
			((GraphicEvent)((Vector)super.source).elementAt(0)).setGraphic(graphic);
	}

	public Vector getGraphicEvents() {
		return (Vector)super.source;
	}

	public void setGraphicEvents(Vector graphicEvents) {
		super.source = graphicEvents;
	}

	public Element toElement() {
		Element element = new Element("composite");

		Vector events = this.getGraphicEvents();
		Iterator iter = events.iterator();
		while(iter.hasNext()) {
			GraphicEvent event = (GraphicEvent)iter.next();
			element.addContent(event.toElement());
		}

		return element;
	}

}