package org.convey;

import java.awt.*;

import java.awt.event.*;

import javax.swing.*;

import java.util.*;

import java.io.*;

/**
 * @author Andy Ames
 * @version 0.2
 */
public class ConnectDialog extends JDialog implements ActionListener, Externalizable {

	protected transient int result;

	protected transient String server;

	protected DefaultComboBoxModel serverComboBoxModel;

	protected transient JComboBox serverComboBox;

	protected transient String user;

	protected Hashtable userComboBoxModels;

	protected transient JComboBox userComboBox;

	protected transient String password;

	protected transient JPasswordField passTextField;

	protected transient JPasswordField retypePassTextField;

	protected transient JLabel retypePassLabel;

	protected transient JCheckBox newUserCheckBox;

	protected transient JCheckBox savePasswordCheckBox;

	protected Hashtable passwords;

	public ConnectDialog() {
		super(ConveyFrame.getConveyFrame(), "Connect", true);
	}

	public ConnectDialog(Frame frame) {
		super(frame, "Connect", true);

		Object[] serverObjects = new Object[]{"jabber.at", "jabber.com", "jabber.org"};
		this.serverComboBoxModel = new DefaultComboBoxModel(serverObjects);
		int i = this.serverComboBoxModel.getSize();

		this.userComboBoxModels = new Hashtable();
		DefaultComboBoxModel model = new DefaultComboBoxModel();
		this.userComboBoxModels.put("jabber.at", model);
		model = new DefaultComboBoxModel();
		this.userComboBoxModels.put("jabber.com", model);
		model = new DefaultComboBoxModel();
		this.userComboBoxModels.put("jabber.org", model);

		this.passwords = new Hashtable();

		init();
	}

	public void init() {
		this.result = JOptionPane.CANCEL_OPTION;

		this.server = "";
		this.serverComboBox = new JComboBox(this.serverComboBoxModel);
		this.serverComboBox.setEditable(true);
		final ConnectDialog thisConnectDialog = this;
		this.serverComboBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(thisConnectDialog.serverComboBox.getSelectedIndex() != -1) {
					String item = (String)thisConnectDialog.serverComboBox.getSelectedItem();
					ComboBoxModel model = (ComboBoxModel)thisConnectDialog.userComboBoxModels.get(item);
					thisConnectDialog.userComboBox.setModel(model);
				} else {
					ComboBoxModel model = new DefaultComboBoxModel();
					thisConnectDialog.userComboBox.setModel(model);
					thisConnectDialog.userComboBoxModels.put(thisConnectDialog.serverComboBox.getSelectedItem(), model);
				}
				doPassword();
			}
		});

		this.user = "";
		this.userComboBox = new JComboBox();
		this.userComboBox.setEditable(true);
		this.userComboBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				doPassword();
			}
		});

		if(this.serverComboBoxModel.getSize() > 0) {
			this.serverComboBox.setSelectedIndex(0);

			ComboBoxModel userModel = (ComboBoxModel)this.userComboBoxModels.get(this.serverComboBox.getSelectedItem());
			this.userComboBox.setModel(userModel);
			if(userModel.getSize() > 0)
				this.userComboBox.setSelectedIndex(0);
		}

		this.passTextField = new JPasswordField();
		this.retypePassTextField = new JPasswordField();
		this.retypePassTextField.setEnabled(false);

		JLabel serverLabel = new JLabel("Server");
		JLabel userLabel = new JLabel("User");
		JLabel passLabel = new JLabel("Password");
		this.retypePassLabel = new JLabel("Retype Password");
		this.retypePassLabel.setEnabled(false);

		Action okAction = new AbstractAction("Ok") {
			public void actionPerformed(ActionEvent e) {
				thisConnectDialog.doAction();
			};
		};

		Action cancelAction = new AbstractAction("Cancel") {
			public void actionPerformed(ActionEvent e) {
				thisConnectDialog.result = JOptionPane.CANCEL_OPTION;
				thisConnectDialog.hide();
			}
		};

		JButton okButton = new JButton(okAction);
		okButton.setDefaultCapable(true);

		JButton cancelButton = new JButton(cancelAction);

		this.newUserCheckBox = new JCheckBox("New User");
		this.newUserCheckBox.addActionListener(this);

		this.savePasswordCheckBox = new JCheckBox("Save Password");

		super.getContentPane().setLayout(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();

		c.gridwidth = 2;
		c.gridy = 0;
		c.anchor = GridBagConstraints.SOUTHWEST;
		c.weighty = 1.0;
		c.weightx = 1.0;
		c.insets = new Insets(3, 3, 3, 3);
		super.getContentPane().add(serverLabel, c);

		c.gridy = 1;
		c.anchor = GridBagConstraints.WEST;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		super.getContentPane().add(this.serverComboBox, c);

		c.gridy = 2;
		c.anchor = GridBagConstraints.SOUTHWEST;
		c.weighty = 1.0;
		c.fill = GridBagConstraints.NONE;
		super.getContentPane().add(userLabel, c);

		c.gridy = 3;
		c.anchor = GridBagConstraints.WEST;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		super.getContentPane().add(this.userComboBox, c);

		c.gridy = 4;
		c.anchor = GridBagConstraints.SOUTHWEST;
		c.weighty = 1.0;
		c.fill = GridBagConstraints.NONE;
		super.getContentPane().add(passLabel, c);

		c.gridy = 5;
		c.anchor = GridBagConstraints.WEST;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		super.getContentPane().add(this.passTextField, c);

		c.gridy = 6;
		c.anchor = GridBagConstraints.WEST;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		super.getContentPane().add(this.savePasswordCheckBox, c);

		c.gridy = 7;
		c.anchor = GridBagConstraints.WEST;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		super.getContentPane().add(this.newUserCheckBox, c);

		c.gridy = 8;
		c.anchor = GridBagConstraints.SOUTHWEST;
		c.weighty = 1.0;
		c.fill = GridBagConstraints.NONE;
		super.getContentPane().add(this.retypePassLabel, c);

		c.gridy = 9;
		c.anchor = GridBagConstraints.WEST;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.HORIZONTAL;
		super.getContentPane().add(this.retypePassTextField, c);

		c.gridwidth = 1;
		c.gridy = 10;
		c.anchor = GridBagConstraints.EAST;
		c.weighty = 1.0;
		c.fill = GridBagConstraints.NONE;
		super.getContentPane().add(okButton, c);

		c.gridx = 1;
		c.anchor = GridBagConstraints.WEST;
		super.getContentPane().add(cancelButton, c);

		super.getRootPane().setDefaultButton(okButton);

		super.enableEvents(AWTEvent.KEY_EVENT_MASK);
	}

	public void show() {
		this.newUserCheckBox.setSelected(false);
		doPassword();
		this.retypePassLabel.setEnabled(false);
		this.retypePassTextField.setEnabled(false);
		this.retypePassTextField.setText("");

		this.result = JOptionPane.CANCEL_OPTION;
		super.pack();

		super.setLocationRelativeTo(super.getParent());

		boolean badPass = true;
		while(badPass) {
			badPass = false;

			super.show();

			if(this.result == JOptionPane.OK_OPTION && this.newUserCheckBox.isSelected()) {
				String p1 = String.valueOf(this.passTextField.getPassword());
				String p2 = String.valueOf(this.retypePassTextField.getPassword());

				if(!p1.equals(p2)) {
					JOptionPane.showMessageDialog(this, "Passwords are not consistant",
																				"Password", JOptionPane.ERROR_MESSAGE);
					badPass = true;
				}
			}
		}
	}

	public int getResult() {
		return this.result;
	}

	public String getServer() {
		return this.server;
	}

	public String getUser() {
		return this.user;
	}

	public String getPassword() {
		return this.password;
	}

	public boolean isNewUser() {
		return this.newUserCheckBox.isSelected();
	}

	public void actionPerformed(ActionEvent e) {
		if(this.newUserCheckBox.isSelected()) {
			this.retypePassLabel.setEnabled(true);
			this.retypePassTextField.setEnabled(true);
		} else {
			this.retypePassLabel.setEnabled(false);
			this.retypePassTextField.setEnabled(false);
			this.retypePassTextField.setText("");
		}
	}

	protected void processKeyEvent(KeyEvent e) {
		if(e.getKeyCode() == KeyEvent.VK_ESCAPE)
			this.hide();
	}

	public void doPassword() {
		if(this.passTextField != null) {
			String serverItem = (String)this.serverComboBox.getSelectedItem();
			String userItem = (String)this.userComboBox.getSelectedItem();
			if(serverItem != null && userItem != null) {
				String key = userItem + "@" + serverItem;
				if(this.passwords.containsKey(key)) {
					this.savePasswordCheckBox.setSelected(true);
					this.passTextField.setText((String)this.passwords.get(key));
				} else {
					this.savePasswordCheckBox.setSelected(false);
					this.passTextField.setText("");
				}
			} else {
				this.savePasswordCheckBox.setSelected(false);
				this.passTextField.setText("");
			}
		}
	}

	public void doAction() {
		this.server = (String)this.serverComboBox.getSelectedItem();
		this.user = (String)this.userComboBox.getSelectedItem();
		this.password = String.valueOf(this.passTextField.getPassword());

		if(this.savePasswordCheckBox.isSelected())
			this.passwords.put(this.user + "@" + this.server, this.password);
		else
			this.passwords.remove(this.user + "@" + this.server);

		DefaultComboBoxModel userModel = (DefaultComboBoxModel)this.userComboBox.getModel();

		if(this.serverComboBox.getSelectedIndex() != -1)
			this.serverComboBoxModel.removeElement(this.server);

		this.serverComboBoxModel.insertElementAt(this.server, 0);
		this.serverComboBox.setSelectedIndex(0);

		if(this.userComboBox.getSelectedIndex() != -1)
			userModel.removeElement(this.user);

		userModel.insertElementAt(this.user, 0);
		this.userComboBox.setSelectedIndex(0);

		this.result = JOptionPane.OK_OPTION;
		this.hide();
	}

	public void writeExternal(ObjectOutput oo) throws IOException {
		oo.writeInt(this.serverComboBoxModel.getSize());
		for(int i = 0; i < this.serverComboBoxModel.getSize(); i++) {
			String str = this.serverComboBoxModel.getElementAt(i).toString();
			oo.writeUTF(str);

			DefaultComboBoxModel model = (DefaultComboBoxModel)this.userComboBoxModels.get(str);
			oo.writeInt(model.getSize());
			for(int j = 0; j < model.getSize(); j++)
				oo.writeUTF(model.getElementAt(j).toString());
		}

		oo.writeInt(this.passwords.size());
		Iterator keyIter = this.passwords.keySet().iterator();
		Iterator valIter = this.passwords.values().iterator();
		while(keyIter.hasNext() && valIter.hasNext()) {
			oo.writeUTF(keyIter.next().toString());
			oo.writeUTF(valIter.next().toString());
		}

		oo.flush();
	}

        public void readExternal(ObjectInput oi) throws IOException, ClassNotFoundException {
          this.serverComboBoxModel = new DefaultComboBoxModel();
          this.userComboBoxModels = new Hashtable();
          this.passwords = new Hashtable();

          int serverCount = oi.readInt();
		for(int i = 0; i < serverCount; i++) {
			String str = oi.readUTF();
			this.serverComboBoxModel.addElement(str);

			DefaultComboBoxModel userComboBoxModel = new DefaultComboBoxModel();
			this.userComboBoxModels.put(str, userComboBoxModel);

			int userCount = oi.readInt();
			for(int j = 0; j < userCount; j++)
				userComboBoxModel.addElement(oi.readUTF());
		}

		int passCount = oi.readInt();
		for(int k = 0; k < passCount; k++)
			this.passwords.put(oi.readUTF(), oi.readUTF());

		init();
	}

}