package org.convey;

import java.awt.geom.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class CubicCurveGraphicEvent extends GraphicEvent {

	protected CubicCurve2D origCurve;

	protected CubicCurve2D newCurve;

	public CubicCurveGraphicEvent(CubicCurveGraphic graphic,
																CubicCurve2D origCurve,
																CubicCurve2D newCurve) {
		super(graphic);
		this.origCurve = (CubicCurve2D)origCurve.clone();
		this.newCurve = (CubicCurve2D)newCurve.clone();
	}

	public CubicCurveGraphic getCubicCurveGraphic() {
		return (CubicCurveGraphic)this.source;
	}

	public void setCubicCurveGraphic(CubicCurveGraphic graphic) {
		this.source = graphic;
	}

	public CubicCurve2D getOrigCurve() {
		return this.origCurve;
	}

	public void setOrigCurve(CubicCurve2D origCurve) {
		this.origCurve = (CubicCurve2D)origCurve.clone();
	}

	public CubicCurve2D getNewCurve() {
		return this.newCurve;
	}

	public void setNewCurve(CubicCurve2D newCurve) {
		this.newCurve = (CubicCurve2D)newCurve.clone();
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("cubicCurve");

		Element o = new Element("old");
		o.setAttribute("x1", String.valueOf(this.origCurve.getX1()));
		o.setAttribute("y1", String.valueOf(this.origCurve.getY1()));
		o.setAttribute("ctrlx1", String.valueOf(this.origCurve.getCtrlX1()));
		o.setAttribute("ctrly1", String.valueOf(this.origCurve.getCtrlY1()));
		o.setAttribute("ctrlx2", String.valueOf(this.origCurve.getCtrlX2()));
		o.setAttribute("ctrly2", String.valueOf(this.origCurve.getCtrlY2()));
		o.setAttribute("x2", String.valueOf(this.origCurve.getX2()));
		o.setAttribute("y2", String.valueOf(this.origCurve.getY2()));

		Element n = new Element("new");
		n.setAttribute("x1", String.valueOf(this.newCurve.getX1()));
		n.setAttribute("y1", String.valueOf(this.newCurve.getY1()));
		n.setAttribute("ctrlx1", String.valueOf(this.newCurve.getCtrlX1()));
		n.setAttribute("ctrly1", String.valueOf(this.newCurve.getCtrlY1()));
		n.setAttribute("ctrlx2", String.valueOf(this.newCurve.getCtrlX2()));
		n.setAttribute("ctrly2", String.valueOf(this.newCurve.getCtrlY2()));
		n.setAttribute("x2", String.valueOf(this.newCurve.getX2()));
		n.setAttribute("y2", String.valueOf(this.newCurve.getY2()));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}