package org.convey;

import java.awt.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class EllipseGraphicEvent extends GraphicEvent {

	protected Rectangle origEllipse;

	protected Rectangle newEllipse;

	public EllipseGraphicEvent(EllipseGraphic graphic, Rectangle origEllipse,
														 Rectangle newEllipse) {
		super(graphic);
		this.origEllipse = (Rectangle)origEllipse.clone();
		this.newEllipse = (Rectangle)newEllipse.clone();
	}

	public EllipseGraphic getEllipseGraphic() {
		return (EllipseGraphic)this.source;
	}

	public void setEllipseGraphic(EllipseGraphic graphic) {
		this.source = graphic;
	}

	public Rectangle getOrigEllipse() {
		return this.origEllipse;
	}

	public void setOrigEllipse(Rectangle origEllipse) {
		this.origEllipse = (Rectangle)origEllipse.clone();
	}

	public Rectangle getNewEllipse() {
		return this.newEllipse;
	}

	public void setNewEllipse(Rectangle newEllipse) {
		this.newEllipse = (Rectangle)newEllipse.clone();
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("ellipse");

		Element o = new Element("old");
		o.setAttribute("x", String.valueOf(this.origEllipse.x));
		o.setAttribute("y", String.valueOf(this.origEllipse.y));
		o.setAttribute("w", String.valueOf(this.origEllipse.width));
		o.setAttribute("h", String.valueOf(this.origEllipse.height));

		Element n = new Element("new");
		n.setAttribute("x", String.valueOf(this.newEllipse.x));
		n.setAttribute("y", String.valueOf(this.newEllipse.y));
		n.setAttribute("w", String.valueOf(this.newEllipse.width));
		n.setAttribute("h", String.valueOf(this.newEllipse.height));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}