package org.convey;

import java.awt.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class FitToRectGraphicEvent extends GraphicEvent {

	protected Rectangle origRect;

	protected Rectangle newRect;

	public FitToRectGraphicEvent(Graphic graphic, Rectangle origRect,
															 Rectangle newRect) {
		super(graphic);
		this.origRect = origRect;
		this.newRect = newRect;
	}

	public void setOrigRect(Rectangle origRect) {
		this.origRect = origRect;
	}

	public Rectangle getOrigRect() {
		return this.origRect;
	}

	public void setNewRect(Rectangle newRect) {
		this.newRect = newRect;
	}

	public Rectangle getNewRect() {
		return this.newRect;
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("fitToRect");

		Element o = new Element("old");
		o.setAttribute("x", String.valueOf(this.origRect.x));
		o.setAttribute("y", String.valueOf(this.origRect.y));
		o.setAttribute("w", String.valueOf(this.origRect.width));
		o.setAttribute("h", String.valueOf(this.origRect.height));

		Element n = new Element("new");
		n.setAttribute("x", String.valueOf(this.newRect.x));
		n.setAttribute("y", String.valueOf(this.newRect.y));
		n.setAttribute("w", String.valueOf(this.newRect.width));
		n.setAttribute("h", String.valueOf(this.newRect.height));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}