package org.convey;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class GraphicNameEvent extends GraphicEvent {

	protected String origName;

	protected String newName;

	public GraphicNameEvent(Graphic graphic, String origName, String newName) {
		super(graphic);
		this.origName = origName;
		this.newName = newName;
	}

	public String getOrigName() {
		return this.origName;
	}

	public void setOrigName(String origName) {
		this.origName = origName;
	}

	public String getNewName() {
		return this.newName;
	}

	public void setNewName(String newName) {
		this.newName = newName;
	}

	public Element toElement() {
		Element element = new Element("name");

		element.setAttribute("old", this.origName);
		element.setAttribute("new", this.newName);

		return element;
	}

}