package org.convey;

import java.util.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class GroupGraphicEvent extends GraphicEvent {

	public static final int TYPE_GROUP = 0;
	public static final int TYPE_UNGROUP = 1;

	public static final int TYPE_MAX = 1;

	protected int type;

	public GroupGraphicEvent(GroupGraphic graphic, int type) {
		super(graphic);
		if(type >= 0 && type <= TYPE_MAX)
			this.type = type;
		else
			this.type = 0;
	}

	public GroupGraphic getGroupGraphic() {
		if(this.source instanceof GroupGraphic)
			return (GroupGraphic)this.source;

		return null;
	}

	public void setGroupGraphic(GroupGraphic graphic) {
		this.source = graphic;
	}

	public int getType() {
		return this.type;
	}

	public void setType(int type) {
		if(type >= 0 && type <= TYPE_MAX)
			this.type = type;
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("group");

		element.setAttribute("type", String.valueOf(this.type));

		if(type == 0) {
			GroupGraphic group = this.getGroupGraphic();
			Iterator iter = group.iterator();
			while(iter.hasNext()) {
				Graphic graphic = (Graphic)iter.next();
				Element child = new Element("graphic");
				child.setAttribute("name", graphic.getName());
				element.addContent(child);
			}
		}

		return element;
	}

}