package org.convey;

import com.echomine.jabber.*;
import com.echomine.common.*;

import org.jdom.*;

/**
 * @author Andy Ames
 * @version 0.2
 */
public class JabberConveyMessage extends JabberChatMessage {

	public static final Namespace CONVEY_XMLNS = Namespace.getNamespace("http://convey.sourceforge.net");

	private Element conveyElement;

	private Element penElement;

	public JabberConveyMessage() {
		super(TYPE_CHAT);
		super.setThreadID(null);
	}

	public JabberMessage parse(JabberMessageParser parser, Element msgTree) throws ParseException {
		super.parse(parser, msgTree);

		this.conveyElement = msgTree.getChild("convey", CONVEY_XMLNS);
		this.penElement = msgTree.getChild("pen", CONVEY_XMLNS);

		return this;
	}

	public Element getConveyElement() {
		return this.conveyElement;
	}

	public Element getPenElement() {
		return this.penElement;
	}

	public void setConveyElement(Element conveyElement) {
		super.getDOM().removeChild("convey", CONVEY_XMLNS);

		this.conveyElement = conveyElement;
		if(this.conveyElement != null)
			super.getDOM().addContent(conveyElement);
	}

	public void setPenElement(Element penElement) {
		super.getDOM().removeChild("pen", CONVEY_XMLNS);

		this.penElement = penElement;
		if(this.penElement != null)
			super.getDOM().addContent(penElement);
	}

	public boolean isConvey() {
		return (this.conveyElement != null);
	}

	public boolean isPen() {
		return (this.penElement != null);
	}

}