package org.convey;

import org.jdom.*;

/**
 * @version 0.3
 */
public class PenEvent {

	public static final int REQUEST = 0;
	public static final int REVOKE = 1;
	public static final int YIELD = 2;
	public static final int DENIED = 3;
	public static final int GRANTED = 4;

	private int type;

	private int timeout = -1;

	public PenEvent(int type) {
		this(type, -1);
	}

	public PenEvent(int type, int timeout) {
		this.setType(type);
		this.setTimeout(timeout);
	}

	public int getType() {
		return this.type;
	}

	public void setType(int type) {
		this.type = type;
	}

	public int getTimeout() {
		return this.timeout;
	}

	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}

	Element toElement() {
		Element element = null;

		switch(this.type) {
			case REQUEST:
				element = new Element("request");
				break;
			case REVOKE:
				element = new Element("revoke");
				element.setAttribute("timeout", String.valueOf(this.timeout));
				break;
			case YIELD:
				element = new Element("yield");
				break;
			case GRANTED:
				element = new Element("granted");
				break;
			case DENIED:
				element = new Element("denied");
				break;
		}

		return element;
	}

}