package org.convey;

import java.awt.*;

import java.awt.geom.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class PolygonGraphicEvent extends GraphicEvent {

	protected int index;

	protected Point2D origPoint;

	protected Point2D newPoint;

	public PolygonGraphicEvent(PolygonGraphic graphic, int index, Point2D origPoint,
														 Point2D newPoint) {
		super(graphic);
		this.index = index;
		this.origPoint = (Point2D)origPoint.clone();
		this.newPoint = (Point2D)newPoint.clone();
	}

	public PolygonGraphic getPolygonGraphic() {
		return (PolygonGraphic)this.source;
	}

	public void setPolygonGraphic(PolygonGraphic graphic) {
		this.source = graphic;
	}

	public int getIndex() {
		return this.index;
	}

	public void setIndex(int index) {
		this.index = index;
	}

	public Point2D getOrigPoint() {
		return this.origPoint;
	}

	public void setOrigPoint(Point2D origPoint) {
		this.origPoint = (Point2D)origPoint.clone();
	}

	public Point2D getNewPoint() {
		return this.newPoint;
	}

	public void setNewPoint(Point2D newPoint) {
		this.newPoint = (Point2D)newPoint.clone();
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("polygon");

		element.setAttribute("index", String.valueOf(this.index));

		Element o = new Element("old");
		o.setAttribute("x", String.valueOf(this.origPoint.getX()));
		o.setAttribute("y", String.valueOf(this.origPoint.getY()));

		Element n = new Element("new");
		n.setAttribute("x", String.valueOf(this.newPoint.getX()));
		n.setAttribute("y", String.valueOf(this.newPoint.getY()));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}