package org.convey;

import org.jdom.*;

/**
 * @version 0.3
 */
public class PositionChangeEvent extends GraphicEvent {

	protected int origIndex;

	protected int newIndex;

	public PositionChangeEvent(Graphic graphic, int origIndex, int newIndex) {
		super(graphic);
		this.origIndex = origIndex;
		this.newIndex = newIndex;
	}

	public int getOrigIndex() {
		return this.origIndex;
	}

	public int getNewIndex() {
		return this.newIndex;
	}

	public void setOrigIndex(int origIndex) {
		this.origIndex = origIndex;
	}

	public void setNewIndex(int origIndex) {
		this.newIndex = newIndex;
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("position");

		element.setAttribute("origIndex", String.valueOf(this.origIndex));
		element.setAttribute("newIndex", String.valueOf(this.newIndex));

		return element;
	}

}