package org.convey;

import javax.swing.*;

import java.awt.event.*;

import java.util.*;

/**
 * @author Andy Ames
 */
public class PropertyFrame extends JFrame {

	protected ShapeGraphicPropertyPanel shapeGraphicPropertyPanel;

	protected Box box = new Box(BoxLayout.Y_AXIS);

	public PropertyFrame() {
		super("Properties");

		this.shapeGraphicPropertyPanel = new ShapeGraphicPropertyPanel();

		super.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		WindowListener l = new WindowAdapter() {
			public void windowClosing(WindowEvent evt) {

			}
		};
		super.addWindowListener(l);

		super.setContentPane(new JScrollPane(this.box, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
																				 JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));

		super.setResizable(false);

		this.box.add(this.shapeGraphicPropertyPanel);

		super.pack();
	}

	public void setSelection(Vector selectedGraphics) {
		if(selectedGraphics.size() == 0) {
			this.shapeGraphicPropertyPanel.setSelectedGraphics(null);
			this.shapeGraphicPropertyPanel.setNoneSelected();
		} else if(selectedGraphics.size() == 1) {
			Graphic graphic = (Graphic)selectedGraphics.elementAt(0);
			if(graphic instanceof ShapeGraphic) {
				this.shapeGraphicPropertyPanel.setSelectedGraphics(selectedGraphics);
				this.shapeGraphicPropertyPanel.setRightTypeSelected();
			} else {
				this.shapeGraphicPropertyPanel.setSelectedGraphics(null);
				this.shapeGraphicPropertyPanel.setWrongTypeSelected();
			}
		} else {
			boolean anyShapeGraphics = false;
			boolean onlyShapeGraphics = true;
			Iterator iter = selectedGraphics.iterator();
			while(iter.hasNext()) {
				Graphic graphic = (Graphic)iter.next();
				if(graphic instanceof ShapeGraphic)
					anyShapeGraphics = true;
				else
					onlyShapeGraphics = false;
			}
			if(anyShapeGraphics && onlyShapeGraphics) {
				this.shapeGraphicPropertyPanel.setSelectedGraphics(selectedGraphics);
				this.shapeGraphicPropertyPanel.setRightTypeSelected();
			} else {
				this.shapeGraphicPropertyPanel.setSelectedGraphics(null);
				this.shapeGraphicPropertyPanel.setWrongTypeSelected();
			}
		}
	}

	public ShapeGraphicPropertyPanel getShapeGraphicPropertyPanel() {
		return this.shapeGraphicPropertyPanel;
	}

}