package org.convey;

import java.awt.geom.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class QuadCurveGraphicEvent extends GraphicEvent {

	protected QuadCurve2D origCurve;

	protected QuadCurve2D newCurve;

	public QuadCurveGraphicEvent(QuadCurveGraphic graphic,
																QuadCurve2D origCurve,
																QuadCurve2D newCurve) {
		super(graphic);
		this.origCurve = (QuadCurve2D)origCurve.clone();
		this.newCurve = (QuadCurve2D)newCurve.clone();
	}

	public QuadCurveGraphic getQuadCurveGraphic() {
		return (QuadCurveGraphic)this.source;
	}

	public void setQuadCurveGraphic(QuadCurveGraphic graphic) {
		this.source = graphic;
	}

	public QuadCurve2D getOrigCurve() {
		return this.origCurve;
	}

	public void setOrigCurve(QuadCurve2D origCurve) {
		this.origCurve = (QuadCurve2D)origCurve.clone();
	}

	public QuadCurve2D getNewCurve() {
		return this.newCurve;
	}

	public void setNewCurve(QuadCurve2D newCurve) {
		this.newCurve = (QuadCurve2D)newCurve.clone();
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("quadCurve");

		Element o = new Element("old");
		o.setAttribute("x1", String.valueOf(this.origCurve.getX1()));
		o.setAttribute("y1", String.valueOf(this.origCurve.getY1()));
		o.setAttribute("ctrlx", String.valueOf(this.origCurve.getCtrlX()));
		o.setAttribute("ctrly", String.valueOf(this.origCurve.getCtrlY()));
		o.setAttribute("x2", String.valueOf(this.origCurve.getX2()));
		o.setAttribute("y2", String.valueOf(this.origCurve.getY2()));

		Element n = new Element("new");
		n.setAttribute("x1", String.valueOf(this.newCurve.getX1()));
		n.setAttribute("y1", String.valueOf(this.newCurve.getY1()));
		n.setAttribute("ctrlx", String.valueOf(this.newCurve.getCtrlX()));
		n.setAttribute("ctrly", String.valueOf(this.newCurve.getCtrlY()));
		n.setAttribute("x2", String.valueOf(this.newCurve.getX2()));
		n.setAttribute("y2", String.valueOf(this.newCurve.getY2()));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}