package org.convey;

import java.awt.*;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class QuadGraphicEvent extends GraphicEvent {

	protected Rectangle origQuad;

	protected Rectangle newQuad;

	public QuadGraphicEvent(QuadGraphic graphic, Rectangle origQuad,
														 Rectangle newQuad) {
		super(graphic);
		this.origQuad = (Rectangle)origQuad.clone();
		this.newQuad = (Rectangle)newQuad.clone();
	}

	public QuadGraphic getQuadGraphic() {
		return (QuadGraphic)this.source;
	}

	public void setQuadGraphic(QuadGraphic graphic) {
		this.source = graphic;
	}

	public Rectangle getOrigQuad() {
		return this.origQuad;
	}

	public void setOrigQuad(Rectangle origQuad) {
		this.origQuad = (Rectangle)origQuad.clone();
	}

	public Rectangle getNewQuad() {
		return this.newQuad;
	}

	public void setNewQuad(Rectangle newQuad) {
		this.newQuad = (Rectangle)newQuad.clone();
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("quad");

		Element o = new Element("old");
		o.setAttribute("x", String.valueOf(this.origQuad.x));
		o.setAttribute("y", String.valueOf(this.origQuad.y));
		o.setAttribute("w", String.valueOf(this.origQuad.width));
		o.setAttribute("h", String.valueOf(this.origQuad.height));

		Element n = new Element("new");
		n.setAttribute("x", String.valueOf(this.newQuad.x));
		n.setAttribute("y", String.valueOf(this.newQuad.y));
		n.setAttribute("w", String.valueOf(this.newQuad.width));
		n.setAttribute("h", String.valueOf(this.newQuad.height));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}