package org.convey;

import org.jdom.*;

import java.awt.*;

/**
 * @author Andy Ames
 */
public class ShapeGraphicEvent extends GraphicEvent {

	public static final int TYPE_FILL = 0;
	public static final int TYPE_STROKE = 1;

	public static final int TYPE_MAX = 1;

	protected int type;

	protected Color origColor;

	protected Color newColor;

	public ShapeGraphicEvent(ShapeGraphic graphic, int type, Color origColor, Color newColor) {
		super(graphic);
		if(type >= 0 && type <= TYPE_MAX)
			this.type = type;
		else
			this.type = 0;
		this.origColor = origColor;
		this.newColor = newColor;
	}

	public ShapeGraphic getShapeGraphic() {
		return (ShapeGraphic)super.source;
	}

	public void setShapeGraphic(ShapeGraphic graphic) {
		super.source = graphic;
	}

	public int getType() {
		return this.type;
	}

	public void setType(int type) {
		if(type >= 0 && type <= TYPE_MAX)
			this.type = type;
	}

	public Color getOrigColor() {
		return this.origColor;
	}

	public void setOrigColor(Color origColor) {
		this.origColor = origColor;
	}

	public Color getNewColor() {
		return this.newColor;
	}

	public void setNewColor(Color newColor) {
		this.newColor = newColor;
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("shape");

		element.setAttribute("type", String.valueOf(this.type));

		element.setAttribute("origColor", ShapeGraphic.colorToString(this.origColor));

		element.setAttribute("newColor", ShapeGraphic.colorToString(this.newColor));

		return element;
	}

}