package org.convey;

import org.jdom.*;

import java.awt.*;

/**
 * @version 0.3
 */
public class TextGraphicEvent extends GraphicEvent {

	protected String origText;

	protected String newText;

	protected Color origColor;

	protected Color newColor;

	public TextGraphicEvent(TextGraphic graphic, String origText, String newText,
													Color origColor, Color newColor) {
		super(graphic);
		this.origText = new String(origText);
		this.newText = new String(newText);
		this.origColor = new Color(origColor.getRed(), origColor.getGreen(), origColor.getBlue());
		this.newColor = new Color(newColor.getRed(), newColor.getGreen(), newColor.getBlue());
	}

	public TextGraphic getTextGraphic() {
		return (TextGraphic)this.source;
	}

	public void setTextGraphic(TextGraphic graphic) {
		this.source = graphic;
	}

	public String getOrigText() {
		return this.origText;
	}

	public void setOrigText(String origText) {
		this.origText = new String(origText);
	}

	public String getNewText() {
		return this.newText;
	}

	public void setNewText(String newText) {
		this.newText = new String(newText);
	}

	public Color getOrigColor() {
		return this.origColor;
	}

	public void setOrigColor(Color origColor) {
		this.origColor = new Color(origColor.getRed(), origColor.getGreen(), origColor.getBlue());
	}

	public Color getNewColor() {
		return this.newColor;
	}

	public void setNewColor(Color newColor) {
		this.newColor = new Color(newColor.getRed(), newColor.getGreen(), newColor.getBlue());
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("text");

		Element o = new Element("old");
		o.addContent(this.origText);
		o.setAttribute("color", Graphic.colorToString(this.origColor));

		Element n = new Element("new");
		n.addContent(this.newText);
		n.setAttribute("color", Graphic.colorToString(this.newColor));

		element.addContent(o);
		element.addContent(n);

		return element;
	}

}