package org.convey;

import org.jdom.*;

/**
 * @author Andy Ames
 */
public class TranslateGraphicEvent extends GraphicEvent {

	protected int x;

	protected int y;

	public TranslateGraphicEvent(Graphic graphic, int x, int y) {
		super(graphic);
		this.x = x;
		this.y = y;
	}

	public int getX() {
		return this.x;
	}

	public void setX(int x) {
		this.x = x;
	}

	public int getY() {
		return this.y;
	}

	public void setY(int y) {
		this.y = y;
	}

	public Element toElement() {
		Element element = super.toElement();

		element.setName("translate");

		element.setAttribute("x", String.valueOf(this.x));
		element.setAttribute("y", String.valueOf(this.y));

		return element;
	}

}